VCMD0028040100000000COMPONENT          
Node "rSimResource"
{
Name "SignalControlledLifter"
Id 1
NodeClass 
{
Id 1
Feature "rPrimitiveBoxFeature"
{
Name "Block"

Matrix 1 0 0 0 0 1 0 0 0 0 1 0 -50 -50 0 1 
Visible 1
Length 
{
  Expression "100 {mm}"
}

Width 
{
  Expression "100 {mm}"
}

Height 
{
  Expression "10"
}

}
VCID "a8ea5892-abab-4928-9a57-5f79716c28d4"
}
Functionality "rPythonScript"
{
Id 1
Name "PythonScript"
Script "from vcScript import *\ncomp = getComponent()
\nservo = comp.getBehaviour(\"ServoController\")
\n
\ndef SetTarget(joint_index = None, joint_value = 0):
\n  for i in range(servo.JointCount):
\n    servo.setJointTarget(i,servo.getJointValue(i))
\n  if joint_index != None:
\n    servo.setJointTarget(joint_index,joint_value)
\n
\ndef OnSignal( signal ):
\n  global joint_map
\n  if signal.Name == \"EmergencyStop\":
\n    if signal.Value:
\n      comp.EmergencyStop = True
\n    else:
\n      comp.EmergencyStop = False
\n  if 'Action' in signal.Name and signal.Value:
\n    suspendRun() # prevents previous servo movement blocking execution of OnRun
\n    joint_name, direction = signal.Name.split(\"_\",1)
\n    joint_index = joint_map[joint_name]
\n    prop_name = joint_name+\"_\"+direction.replace(\"Action\",\"Value\")
\n    joint_value = comp.getProperty(prop_name).Value
\n    SetTarget(joint_index,joint_value)
\n    resumeRun()
\n
\ndef SetStateSignals(reset = False):
\n  for i,j in enumerate(servo.Joints):
\n    joint_name = j.Name
\n    min_state_signal = comp.findBehaviour(joint_name + '_' + comp.MaxName + 'State')
\n    max_state_signal = comp.findBehaviour(joint_name + '_' + comp.MinName +  'State')
\n    min_val_prop = comp.getProperty(joint_name + '_' + comp.MaxName + 'Value')
\n    max_val_prop = comp.getProperty(joint_name + '_' + comp.MinName + 'Value')
\n    if all([min_val_prop, max_val_prop, min_state_signal, max_state_signal]):
\n      if j.CurrentValue == min_val_prop.Value and reset == False:
\n        min_state_signal.signal(True)
\n      else:
\n        min_state_signal.signal(False)
\n      if j.CurrentValue == max_val_prop.Value and reset == False:
\n        max_state_signal.signal(True)
\n      else:
\n        max_state_signal.signal(False)
\n
\ndef OnRun():
\n  global joint_map
\n  SetTarget()
\n  delay(1)
\n  comp.PowerOn = True
\n  comp.EmergencyStop = False
\n  joint_map = {}
\n  for i,j in enumerate(servo.Joints):
\n    joint_map[j.Name] = i
\n  while True:
\n    SetStateSignals(False)
\n    condition(lambda:comp.PowerOn and not comp.EmergencyStop and [i for i in range(servo.JointCount) if (round(servo.getJointTarget(i),2) != round(servo.getJointValue(i),2))])
\n    SetStateSignals(True)
\n    servo.move()
\n  
\ndef CallPowerOn(arg):
\n  if not arg.Value:
\n    SetTarget()
\n
\ndef CallEmergencyStop(arg):
\n  if arg.Value:
\n    SetTarget()
\n  
\npower_prop = comp.getProperty(\"PowerOn\")
\npower_prop.OnChanged = CallPowerOn
\nemerg_prop = comp.getProperty(\"EmergencyStop\")
\nemerg_prop.OnChanged = CallEmergencyStop"
CompatibilityMode 0
}
Functionality "rSimKinController"
{
Id 2
Name "ServoController"
Joints
{
  JointInfo
  {
    Index 0
    DofObject "J1"
  }
}
DummyDofs
{
}
UseHeartbeat 0
HeartRate 0
UsePhysicalHeartbeat 0
RootNode "SignalControlledLifter"
FlangeNode "Link_1"
}
Functionality "rSimBoolSignal"
{
Id 3
Name "J1_OpenAction"
Connections
{
"PythonScript"
}
AutomaticReset 1
}
Functionality "rSimBoolSignal"
{
Id 4
Name "J1_ClosedAction"
Connections
{
"PythonScript"
}
AutomaticReset 1
}
Functionality "rSimBoolSignal"
{
Id 5
Name "EmergencyStop"
Connections
{
"PythonScript"
}
AutomaticReset 1
}
Functionality "rSimBoolSignal"
{
Id 6
Name "J1_OpenState"
Connections
{
}
AutomaticReset 1
}
Functionality "rSimBoolSignal"
{
Id 7
Name "J1_ClosedState"
Connections
{
}
AutomaticReset 1
}
VCID a8ea5892-abab-4928-9a57-5f79716c28d4
Revision 8
Location 1 0 0 0 0 1 0 0 0 0 1 0 0 0 0 1 
ActiveSimulationLevel detailed
BOMname  "NewComponent"

BOMdescription  ""

Category  ""

VariableSpace ""
{
  Variable "rTVariable<rBool>"
  {
    Name "Visible"
    Value 1
    Group -1130
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
    }
  }
  Variable "rTVariable<rDouble>"
  {
    Name "J1_OpenValue"
    Value 500
    Group 40
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rDouble>"
  {
    Name "J1_ClosedValue"
    Value 0
    Group 50
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rString>"
  {
    Name "MinName"
    Value "Closed"
    Group 60
    Settings
    {
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rString>"
  {
    Name "MaxName"
    Value "Open"
    Group 70
    Settings
    {
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rBool>"
  {
    Name "EmergencyStop"
    Value 0
    Group 80
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rBool>"
  {
    Name "PowerOn"
    Value 1
    Group 90
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      TRANSLATE_USING_GETTEXT
    }
  }
}
Node "rSimLink"
{
Name "Link_1"
Id 2
NodeClass 
{
Id 2
Feature "rPrimitiveCylinderFeature"
{
Name "Cylinder"

Visible 1
Radius 
{
  Expression "50 {mm}"
}

Height 
{
  Expression "100 {mm}"
}

StartSweep 
{
  Expression "0 {deg}"
}

EndSweep 
{
  Expression "360 {deg}"
}

Sections 
{
  Expression "12"
}

Caps 1
}
}
Dof  "Translational"
{
  Name "J1"
  Properties
  {
    Variable "rTExpressionVariable<rDouble>"
    {
      Name "SoftMinLimit"
      Value
      {
        Expression ""
      }
      Group 33
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
      }
    }
    Variable "rTExpressionVariable<rDouble>"
    {
      Name "SoftMaxLimit"
      Value
      {
        Expression ""
      }
      Group 34
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
      }
    }
    Variable "rTVariable<rDouble>"
    {
      Name "MaxSpeed"
      Value 100
      Group 35
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
        TRANSLATE_USING_GETTEXT
      }
      Quantity "Speed" "ScalarQuantity"
      {
        Groups
        {
          UnitGroup "US Speed"
          {
            Unit
            {
              Name "feet per minute"
              Suffix "fpm"
              Factor 5.07999992370605
              Offset 0
            }
            Family "US degrees"
            Family "a"
          }
          UnitGroup "mm/min"
          {
            Unit
            {
              Name "dfdf"
              Suffix "m/min"
              Factor 1
              Offset 0
            }
          }
        }
      }
      Magnitude 1
    }
    Variable "rTVariable<rDouble>"
    {
      Name "MaxAcceleration"
      Value 500
      Group 36
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
        TRANSLATE_USING_GETTEXT
      }
      Quantity "Acceleration"
      Magnitude 1
    }
    Variable "rTVariable<rDouble>"
    {
      Name "MaxDeceleration"
      Value 500
      Group 37
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
        TRANSLATE_USING_GETTEXT
      }
      Quantity "Acceleration"
      Magnitude 1
    }
    Variable "rTVariable<rDouble>"
    {
      Name "LagTime"
      Value 0
      Group 41
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
        TRANSLATE_USING_GETTEXT
      }
      Quantity "Time"
      Magnitude 1
    }
    Variable "rTVariable<rDouble>"
    {
      Name "SettleTime"
      Value 0
      Group 42
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
        TRANSLATE_USING_GETTEXT
      }
      Quantity "Time"
      Magnitude 1
    }
  }
  JointValue 0
  MinLimit
  {
    Expression ""
  }
  MaxLimit
  {
    Expression ""
  }
  AxisType 2
  JointDeflection
  {
    Expression "VALUE"
  }
}
Offset 
{
  Expression ""
}
}
}
